# mypy-boto3-appstream

[![PyPI - mypy-boto3-appstream](https://img.shields.io/pypi/v/mypy-boto3-appstream.svg?color=blue)](https://pypi.org/project/mypy-boto3-appstream)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-appstream.svg?color=blue)](https://pypi.org/project/mypy-boto3-appstream)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-appstream](#mypy-boto3-appstream)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.AppStream 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/appstream.html#AppStream) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-appstream](#mypy-boto3-appstream)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `AppStream` service.

```bash
python -m pip install boto3-stubs[appstream]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_appstream` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_appstream import AppStreamClient

# Now mypy can check if your code is valid.
client: AppStreamClient = boto3.client("appstream")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AppStreamClient = session.client("appstream")



# Waiters are also supported

import mypy_boto3_appstream.waiter as appstream_waiters

fleet_started_waiter: appstream_waiters.FleetStartedWaiter = client.get_waiter("fleet_started")
fleet_stopped_waiter: appstream_waiters.FleetStoppedWaiter = client.get_waiter("fleet_stopped")


# Annotated paginators are included as well

import mypy_boto3_appstream.paginator as appstream_paginators

describe_directory_configs_paginator: appstream_paginators.DescribeDirectoryConfigsPaginator = client.get_paginator("describe_directory_configs")
describe_fleets_paginator: appstream_paginators.DescribeFleetsPaginator = client.get_paginator("describe_fleets")
describe_image_builders_paginator: appstream_paginators.DescribeImageBuildersPaginator = client.get_paginator("describe_image_builders")
describe_images_paginator: appstream_paginators.DescribeImagesPaginator = client.get_paginator("describe_images")
describe_sessions_paginator: appstream_paginators.DescribeSessionsPaginator = client.get_paginator("describe_sessions")
describe_stacks_paginator: appstream_paginators.DescribeStacksPaginator = client.get_paginator("describe_stacks")
describe_user_stack_associations_paginator: appstream_paginators.DescribeUserStackAssociationsPaginator = client.get_paginator("describe_user_stack_associations")
describe_users_paginator: appstream_paginators.DescribeUsersPaginator = client.get_paginator("describe_users")
list_associated_fleets_paginator: appstream_paginators.ListAssociatedFleetsPaginator = client.get_paginator("list_associated_fleets")
list_associated_stacks_paginator: appstream_paginators.ListAssociatedStacksPaginator = client.get_paginator("list_associated_stacks")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_appstream` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_appstream as appstream
from mypy_boto3_appstream import AppStreamClient

# with these
from mypy_boto3 import appstream
from mypy_boto3.appstream import AppStreamClient
```